package aes;

public class VisualizationVariablesContainer {

    private int blockCount;

    private AllRoundsStateArrays[] values;

    private byte[] key;

    public void setKey(byte[] key) {
        this.key = key;
    }

    public byte[] getKey() {
        return key;
    }

    public VisualizationVariablesContainer(int blockCount) {
        this.blockCount = blockCount;
        values = new AllRoundsStateArrays[blockCount];
        for (int i = 0; i < values.length; i++) {
            values[i] = new AllRoundsStateArrays();
        }
    }

    public void addPhase(byte[] values, int blockIndex, int phaseIndex) {
        this.values[blockIndex].setStateArrayPhase(phaseIndex, new StateArrayPhase(values));
    }

    public void addPhase(byte[][] values, int blockIndex, int phaseIndex) {
        this.values[blockIndex].setStateArrayPhase(phaseIndex, new StateArrayPhase(values));
    }

    public byte[][] getPhase(int blockIndex, int phaseIndex) {
        return values[blockIndex].getPhase(phaseIndex).getValues();
    }

    private class StateArrayPhase {

        private byte[][] values;

        public StateArrayPhase(byte[] values) {
            this.values = new byte[4][4];
            if (values.length == 16) {
                for (int i = 0; i < 4; i++) {
                    for (int j = 0; j < 4; j++) {
                        this.values[i][j] = values[i * 3 + j];
                    }
                }
            }
        }

        public StateArrayPhase(byte[][] values) {
            byte[][] val = new byte[4][4];
            for (int i = 0; i < values.length; i++) {
                for (int j = 0; j < values[i].length; j++) {
                    val[i][j] = values[i][j];
                }
            }
            this.values = val;
        }

        public byte[][] getValues() {
            return values;
        }
    }

    private class AllRoundsStateArrays {

        private StateArrayPhase[] values;

        public AllRoundsStateArrays() {
            values = new StateArrayPhase[41];
        }

        public StateArrayPhase getPhase(int phaseIndex) {
            return values[phaseIndex];
        }

        public void setStateArrayPhase(int phaseIndex, StateArrayPhase phase) {
            values[phaseIndex] = phase;
        }
    }

    public byte[] getPlainText() {
        byte[] pt = new byte[blockCount * 16];
        for (int c = 0; c < blockCount; c++) {
            for (int i = 0; i < 4; i++) {
                for (int j = 0; j < 4; j++) {
                    pt[(c * 16) + (i * 4) + j] = values[c].values[0].values[j][i];
                }
            }
        }
        return pt;
    }

    ;

    public byte[] getCipherText() {
        byte[] ct = new byte[blockCount * 16];
        for (int c = 0; c < blockCount; c++) {
            for (int i = 0; i < 4; i++) {
                for (int j = 0; j < 4; j++) {
                    ct[(c * 16) + (i * 4) + j] = values[c].values[40].values[j][i];
                }
            }
        }
        return ct;
    }

    ;
}
