package javafxmainapplication;

import aes.AESWithAllPhasesStored;
import aes.VisualizationVariablesContainer;
import customControls.KeyInputControl;
import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;
import javafx.beans.InvalidationListener;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.TextArea;
import javafx.scene.layout.Region;
import javafx.stage.Stage;

public class FXML_StartPageController implements Initializable {

    @FXML
    KeyInputControl keyControl;

    @FXML
    TextArea plainTextTextArea;

    private byte[] plaintext;

    private byte[] ciphertext;

    private byte[] key;

    public void initialize(URL url, ResourceBundle rb) {
    }

    public byte[] getPlaintext() {
        return plaintext;
    }

    public void setPlaintext(byte[] plaintext) {
        this.plaintext = plaintext;
    }

    public byte[] getCiphertext() {
        return ciphertext;
    }

    public void setCiphertext(byte[] ciphertext) {
        this.ciphertext = ciphertext;
    }

    public byte[] getKey() {
        return key;
    }

    public void setKey(byte[] key) {
        this.key = key;
    }

    @FXML
    private void handleShowingVisualisation(ActionEvent event) throws IOException, Exception {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("FXML_MainWindow.fxml"));
            Button btn = (Button) event.getSource();
            Parent root1 = (Parent) fxmlLoader.load();
            FXML_MainWindowController controller = fxmlLoader.getController();
            AESWithAllPhasesStored aes = new AESWithAllPhasesStored();
            VisualizationVariablesContainer aesData = aes.encrypt(plainTextTextArea.getText(), keyControl.getKey());
            byte[] plainText = aesData.getPlainText();
            controller.setMiddleTextToStateArray();
            controller.setPlainText(plainText);
            controller.setCipherText(aesData.getCipherText());
            controller.fillPlainText(0);
            controller.set(aesData);
            controller.setStataArrayToInputOutputControl();
            controller.setPlainTextCipherTextControlToStateArray();
            controller.setSboxToStateArray();
            controller.setKey(aes.keyToByteArray());
            controller.setKeyFieldToStateArray();
            controller.setOriginalKey(keyControl.getKey());
            Stage stage = (Stage) btn.getScene().getWindow();
            ((Region) root1).widthProperty().addListener(new InvalidationListener() {

                @Override
                public void invalidated(javafx.beans.Observable observable) {
                    root1.layout();
                }
            });
            ((Region) root1).heightProperty().addListener(new InvalidationListener() {

                @Override
                public void invalidated(javafx.beans.Observable observable) {
                    root1.layout();
                }
            });
            stage.setResizable(true);
            stage.setMinHeight(768);
            stage.setMinWidth(1366);
            stage.setScene(new Scene(root1));
            stage.centerOnScreen();
            ((Region) root1).layout();
        } catch (Exception e) {
            Alert alert = new Alert(Alert.AlertType.INFORMATION);
            alert.setTitle("Information Dialog");
            alert.setHeaderText("Missing key or plaintext");
            alert.setContentText("To see the actual visualization please make sure that you entered both plaintext and the key.");
            alert.showAndWait();
        }
    }
}
